package com.jorgecastillo.kanadrill;

import android.content.SharedPreferences;
import android.content.res.Resources;
import android.os.Bundle;
import android.app.Activity;
import android.preference.PreferenceManager;
import android.text.method.ScrollingMovementMethod;
import android.widget.TextView;

public class TableActivity extends Activity {

    protected TextView textViewTabla;
    protected Resources myResources;
    protected String[] meaning;
    protected String[] japanese;
    protected SharedPreferences myPreferences;
    protected int theme_list;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        myPreferences = PreferenceManager.getDefaultSharedPreferences(this);
        if (myPreferences.getBoolean("setup_true", false)) {
            theme_list= Integer.parseInt(myPreferences.getString("theme_list", "1"));
            CommonCode.theme_list = theme_list;
            switch (theme_list){
                case 1:
                    setTheme(R.style.HoloLight);
                case 2:
                    setTheme(R.style.HoloDark);
                case 3:
                    setTheme(R.style.MaterialLight);
                case 4:
                    setTheme(R.style.MaterialDark);
                default:
                    break;
            }
        }

        setContentView(R.layout.activity_table);
        textViewTabla = (TextView) findViewById(R.id.textViewTabla);

        myResources = getResources();
        setArrays();
        fillTable();

    }

    public void setArrays() {}

    public void fillTable() {
        int n = meaning.length;
        String textTable = "";
        for(int i = 0; i < n ; i++){
            textTable += "" + meaning[i] + japanese[i] + "  ";
            if ( (i + 1) % 5 == 0) {
                textTable += "\n\n";
            }
        }
        textViewTabla.setText(textTable);
        textViewTabla.setMovementMethod(new ScrollingMovementMethod());
    }

}
